        name    bblock
        title   'bblock.com'

cseg    segment para    public  'CODE'
        org 0h
        assume  cs:cseg,ds:cseg,es:cseg,ss:cseg

bblock  proc near

BOOTCODE	=	7c00h		; boot code entry
BOOTSEG		=	7c0h		; boot segment
VECTOR		=	00h		; vector segment

;		Bootstrap Entrypoint
;

bb1:
        mov     ax, cs          ; resets segments registers
        mov     es, ax
	mov	ss, ax
        mov     ax, 7c0h        ; data segment
        mov     ds, ax
	mov	sp,7c00h	; set up a stack
        
        mov     ax, 0           ; reset floppy disk controller
        int     13h             ; do interrupt

        mov     bx, offset strmsg ; start message
        call    print
        
        mov     bx, offset vecmsg
        call print
        push    es              ; save es
        mov     ax,0            ; loads vector area buffer
        mov     es,ax
        mov     bx,0
        mov     al, 4           ; 4 sectors 2Kbytes
        mov     dl, 0           ; drive 0
        mov     dh, 0           ; head 0
        mov     cl, 2           ; sector 2
        mov     ah, 3           ; write command
        int     13h             ; int
        jc      error           ; if error jump to message
        pop     es              ; recuperate es
        
        mov     bx, offset finmsg ; end message
        call    print
        jmp     err1            ; loops forevers, but Ok.

error:
        mov     bx, offset errmsg
        call print
err1:                           ; loops forever.
        jmp     err1

print:  push    ax              ; prints string, bx has buffer
        push    bx              ; and string ends with 0
        push    cx
        push    dx
pr1:    push    bx              ; push pointer
        mov     al, ds:[bx]     ; get char
        or      al, al          ; check for end
        jz      pr2             ; jump to finish
        mov     ah, 0eh         ; print code
        mov     bh,0            ; page
        int     10h             ; int to BIOS
        pop     bx              ; restore pointer to bx
        inc     bx              ; next char
        jmp     pr1             ; loop
pr2:
        pop     bx
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret        

bblock  endp

strmsg:  db    'Starting BootBlock ...',0dh,0ah,0
finmsg:  db    'Ending BootBlock, reboot without floppy in A ...',0dh,0ah,0
errmsg:  db    'Error, looping, try with other floppy ...',0dh,0ah,0
vecmsg:  db    'Writing vector area to floppy disk A ...',0dh,0ah,0

cseg    ends

end bblock


